import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Ball here.
 * 
 * Author: Zac Saunders
 * Current Version: 4.0
 * Past Versions:
 * 1.0- Introduced the Horizontal/Verticle Speed variables.
 * 1.5- Added the movement method which creates the "bouncing" effect.
 * 2.0- Edited the movement class to react differerntly to each edge of the map. This is nessesary to create a appealing, logical "bouncing" effect.
 * 2.5- Introduced the ways that the ball will react to the objects.
 * 3.0- Specified how the ball will react to each object individually.
 * 3.5- Fixed syntax errors that were causing the objects to not perform their correct actions.
 * 4.0- Added comments to explain the methods and individual lines.
 */
public class Ball extends Actor
{  
    private int hSpeed = 3, vSpeed = 5;

    /** 
     *  hSpeed = Horizontal Speed
     *  vSpeed = Verticle Speed
     *  The values of these variables control the angle of reaction that the balls...
     *  ...have to the border of the world. 
    */

   
    public void act() 
    {
        movement();
        getWorld().addObject(new Trail(),getX(),getY()); //automatically spawns the trail when the the ball is spawned.
        intersectingObjects();            
    }
   
    /**
     * This class tells the ball to react to the borders of the world by reversing its direction.
     * By doing this, the balls appear to have a bouncing effect.
     */
    
    public void movement()
    {
        setLocation( getX() + hSpeed, getY() + vSpeed);
        if(getX()<5) {
            hSpeed = -hSpeed;
        } 
        //When the ball hits this edge of the world, the balls hSpeed(Horizontal Speed) will be inversed. This will cause the "bouncing" effect.
        if(getY()<5) {
            vSpeed = -vSpeed;
        }
        //When the ball hits this edge of the world, the balls vSpeed(Verticle Speed) will be inversed. This will cause the "bouncing" effect.
        if(getX() > getWorld().getWidth()-5){
            hSpeed = -hSpeed;
        }
        //When the ball hits this edge of the world, the balls hSpeed(Horizontal Speed) will be inversed. This will cause the "bouncing" effect.
        if(getY() > getWorld().getHeight()-5){
            vSpeed = -vSpeed;
        }
        //When the ball hits this edge of the world, the balls vSpeed(Verticle Speed) will be inversed. This will cause the "bouncing" effect.
    }
    
    public void intersectingObjects()
    {
        
        Actor paddle = getOneIntersectingObject(Paddle.class);
        //This tells the ball that when it intersects with a paddle to bounce-off. 
        if( paddle != null ){
           hSpeed = -hSpeed ;
        }
        
        Actor yballoon = getOneIntersectingObject(Yballoon.class);
        //This tells the world to delete the yellow balloon when the ball hits it.
        if( yballoon != null ){
           getWorld().removeObject(yballoon); 
        }
        
        Actor rballoon = getOneIntersectingObject(Rballoon.class);
        //This tells the world to delete the red balloon when the ball hits it.
        if( rballoon != null ){
           getWorld().removeObject(rballoon); 
        }
        
        Actor bballoon = getOneIntersectingObject(Bballoon.class);
        //This tells the world to delete the blue balloon when the ball hits it.
        if( bballoon != null ){
           getWorld().removeObject(bballoon); 
        }
        
        Actor bomb = getOneIntersectingObject(Bomb.class);
        //This tells the world to delete the bomb when the ball hits it.
        if( bomb != null ){
           getWorld().removeObject(bomb); 
        }
    }
}
